/* Generate A Sequence of bimg runs */
      #include <stdio.h>
      #include <stdlib.h>
      #include <float.h>
      #include <math.h>
      #include <string.h>
      #include <time.h>

int 	main(int argc, char *argv[]) {
	FILE	*h1;
	char	outfile[]="gobimg";
	char	infile[20];
	char	infileshort[13];
	char	tail[]=".seg";
	float	tend;
	float	tstart;
	float	tstep;
	float	tgate;
	float	tlagmx;
	int	j, nstep;
	float	t1, t2;
	int	tr1, trN;
	int	jnear, jfar;
	float	rescale;
	int	mix;
	int	mixatend;

	mixatend = 1;   // 1= mix at end compile gives same results, faster execution
			// 0= mix at each window move up

	if(argc<12 ) {
	puts("USAGE: genbimg filename tstart tend tstep tgate tlagmx trace1 traceN jnear jfar mix  \n");
	puts("filename = input file name");
	puts("tstart   = start time (float, seconds) of processing");
	puts("tend     = end time (float, seconds) of processing)");
	puts("tstep    = time shift forward with sliding window (float, seconds) of processing)");
	puts("tgate    = length in time of sliding window (float, seconds)  ");
	puts("tlagmx   = 2 sided maximum correlation lag (float, seconds)   ");
	puts("trace1   = first trace to process (int)  ");
	puts("traceN   = last trace to process (int)  ");
	puts("jnear    = near correlation separation (int, traces)  ");
	puts("jfar     = far  correlation separation (int, traces)  ");
	puts("mix      = mean mix length (0=no mix)  (int, traces)  ");
	puts("\n ABORT");
	fprintf(stderr," you only have %d arguments on command line \n",argc);
	for (j=0; j<argc; j++) fprintf(stderr,"argv[%d] = %s \n",j,argv[j]);
	return(1);
	}
	else {
	strncpy(infile,argv[1],19);
	tstart = atof(argv[2]);
	tend = atof(argv[3]);
	tstep = atof(argv[4]);
	tgate = atof(argv[5]);
	tlagmx = atof(argv[6]);
	tr1 = atoi(argv[7]);
	trN = atoi(argv[8]);
	jnear = atoi(argv[9]);
	jfar  = atoi(argv[10]);
	mix   = atoi(argv[11]);
	} //endif

//open output file for writing
        if( (h1=fopen(outfile,"w"))==NULL )
        {
        printf("\n ABORT !! Error opening file %s \n",outfile);
	fflush(stderr);
	  abort();
        }
	fprintf(h1,"#!/bin/bash \n");

//...echocheck
	fprintf(h1,"# Input File          = %s \n",infile);
	fprintf(h1,"# Start Time          = %.2f sec. \n",tstart);
	fprintf(h1,"# End Time            = %.2f sec. \n",tend);
	fprintf(h1,"# Time Step (moveups) = %.2f sec. \n",tstep);
	fprintf(h1,"# Time Gate           = %.2f sec. \n",tgate);
	fprintf(h1,"# Max Lag             = %.2f sec. \n",tlagmx);
	fprintf(h1,"# First Trace Number  = %d \n",tr1);
	fprintf(h1,"# Last Trace Number   = %d \n",trN);
	fprintf(h1,"# Near correlation trace spacing   = %d \n",jnear);
	fprintf(h1,"# Far  correlation trace spacing   = %d \n",jfar );
	fprintf(h1,"# mix  mean mix length in traces   = %d \n",mix  );
	fprintf(h1,"#  \n");

//...defind infileshort name
	strncpy(infileshort,infile,4);
	for (j=4; j<8; j++) infileshort[j]=tail[j-4];
	infileshort[8]='\0'; 

// Generate loop of commands
	nstep = (tend - tstart)/tstep;
	t1=tstart;
	t2=t1 + tgate;
	fprintf(h1,"echo ""gate: %.1f %.1f "" \n ",t1,t2);
	fprintf(h1,"bedt %s %f %f %d %d 1 0 >/dev/null \n",infile,t1,t2,tr1,trN);
	fprintf(h1,"brdc bedt%s 1 >/dev/null \n",infileshort);
	fprintf(h1,"bimg brdcbedt.seg 0. %f %f %i %i >/dev/null \n",tgate,tlagmx,jnear,jfar);
           /*Filter out infinite apparent velocity using mean mix  */
	if (mixatend == 0 ) {
		if (mix > 0 ) {
		fprintf(h1," bmix bimgbrdc.seg %d >/dev/null \n",mix);
		fprintf(h1," bsum bimgbrdc.seg bmixbimg.seg -1.0 >/dev/null \n");
		fprintf(h1,"mv  bsumbimg.seg  stak.seg \n");
		fprintf(h1," bmix BIMGbrdc.seg %d  >/dev/null \n",mix);
		fprintf(h1," bsum BIMGbrdc.seg bmixBIMG.seg -1.0 >/dev/null \n");
		fprintf(h1,"mv  bsumBIMG.seg  STAK.seg \n");
		} //endif
	}
	else {
	fprintf(h1,"mv  bimgbrdc.seg  stak.seg \n");
	fprintf(h1,"mv  BIMGbrdc.seg  STAK.seg \n");
	} //endif
	t1 = t1 +tstep;
	for (j=0; j<nstep-1; j++) {
	t2=t1 + tgate;
	fprintf(h1,"echo ""gate: %.1f %.1f "" \n ",t1,t2);
	fprintf(h1,"bedt %s %f %f %d %d 1 0 >/dev/null \n",infile,t1,t2,tr1,trN);
	fprintf(h1,"brdc bedt%s 1 >/dev/null \n",infileshort);
	fprintf(h1,"bimg brdcbedt.seg 0. %f %f %i %i >/dev/null \n",tgate,tlagmx,jnear,jfar);
	if (mixatend == 0) {
		if (mix > 0 ) {
		fprintf(h1," bmix bimgbrdc.seg %d >/dev/null \n",mix);
		fprintf(h1," bsum bimgbrdc.seg bmixbimg.seg -1.0 >/dev/null \n");
		fprintf(h1,"bsum bsumbimg.seg  stak.seg 1.0 >/dev/null \n");
		fprintf(h1,"mv bsumbsum.seg stak.seg \n");
		fprintf(h1," bmix BIMGbrdc.seg %d >/dev/null \n",mix);
		fprintf(h1," bsum BIMGbrdc.seg bmixBIMG.seg -1.0 >/dev/null \n");
		fprintf(h1,"bsum bsumBIMG.seg  STAK.seg 1.0 >/dev/null \n");
		fprintf(h1,"mv bsumbsum.seg STAK.seg \n");
		} //endif
	}
	else
	{
	fprintf(h1,"bsum bimgbrdc.seg  stak.seg 1.0 >/dev/null \n");
	fprintf(h1,"mv bsumbimg.seg stak.seg \n");
	fprintf(h1,"bsum BIMGbrdc.seg  STAK.seg 1.0 >/dev/null \n");
	fprintf(h1,"mv bsumBIMG.seg STAK.seg \n");
	} //endif

	t1 = t1 + tstep; 	
	} //next j

	/* rescale result by number of window moveups */
	rescale = 1.0 / (float) nstep;
	fprintf(h1,"bscl stak.seg 1 1 0 %f >/dev/null \n",rescale);
	fprintf(h1,"mv bsclstak.seg stak.seg \n");
	fprintf(h1,"bscl STAK.seg 1 1 0 %f >/dev/null \n",rescale);
	fprintf(h1,"mv bsclSTAK.seg STAK.seg \n");

	/* This seems to give same results as mixing at each window moveup */
	if (mixatend == 1 ) {
		if (mix > 0 ) {	
		fprintf(h1,"bmix stak.seg %d >/dev/null \n",mix);
		fprintf(h1,"bsum stak.seg bmixstak.seg -1.0 >/dev/null \n");
		fprintf(h1,"mv bsumstak.seg stak.seg \n");
		fprintf(h1,"bmix STAK.seg %d >/dev/null \n",mix);
		fprintf(h1,"bsum STAK.seg bmixSTAK.seg -1.0 >/dev/null \n");
		fprintf(h1,"mv bsumSTAK.seg STAK.seg \n");
		} //endif
	} //endif

	fprintf(h1,"bplt stak.seg 1 0 1 %d %d 0. %f 1 4. 200 \n",tr1,trN,tlagmx);
	fprintf(h1,"ps2pdf bplt.ps \n");
	fprintf(h1,"mv bplt.pdf stak.pdf \n");
	fprintf(h1,"rm -f bplt.ps \n");
	fprintf(h1,"bplt STAK.seg 1 0 1 %d %d 0. %f 1 4. 200 \n",tr1,trN,tlagmx);
	fprintf(h1,"ps2pdf bplt.ps \n");
	fprintf(h1,"mv bplt.pdf STAK.pdf \n");
	fprintf(h1,"rm -f bplt.ps \n");
	fclose(h1);
	system("chmod +x gobimg");
	puts("SUCESS Now you run the output script");
	printf("Output Bash Script ==> gobimg \n");
	printf(" (type gobimg)     ==> images:  stak.pdf and STAK.pdf \n");
	printf("                   ==> data:    stak.seg and STAK.seg \n");
} //endmain

